require('./scss/spinner.scss');

class Spinner {

    constructor(element) {
        this.element = element;
    }

    get spinner() {
        if (typeof this._spinner === 'undefined') {
            let style = window.getComputedStyle(this.wrapper),
                padding = parseInt(style.paddingTop),
                size = this.wrapper.getBoundingClientRect().height - (padding * 2);

            this._spinner = document.createElement('div');
            this._spinner.classList.add('ep-spinner', 'fade');

            this.wrapper.appendChild(this._spinner);
        }
        return this._spinner;
    }

    get wrapper() {
        if (typeof this._wrapper === 'undefined') {
            let rect = this.element.getBoundingClientRect();

            this._wrapper = document.createElement('div');
            this._wrapper.classList.add('ep-spinner__input');
            this._wrapper.style.top = this.element.offsetTop + 'px';
            this._wrapper.style.width = rect.height + 'px';
            this._wrapper.style.height = rect.height + 'px';

            if ('SELECT' === this.element.nodeName) {
                this._wrapper.style.left = (this.element.offsetLeft - rect.height) + 'px';
            } else if ('BUTTON' === this.element.nodeName) {
                this._wrapper.style.left = (this.element.offsetLeft + rect.width + 5) + 'px';
            } else {
                this._wrapper.style.left = (this.element.offsetLeft + (rect.width - rect.height)) + 'px';
            }

            this.element.insertAdjacentElement('afterend', this._wrapper);
        }
        return this._wrapper;
    }

    show() {
        this.spinner.classList.add('in');
    }

    hide() {
        this.spinner.classList.remove('in');
    }
}

export default Spinner;
module.exports = Spinner;