import $ from 'jquery';
import 'bootstrap';
import Spinner from './component/Spinner';

require('./scss/settings.scss');

class SettingsForm
{
    constructor(form) {
        this.$form = $(form);

        this.bind();
    }

    get button() {
        return this.$form.find('[type="submit"]')[0];
    }

    get spinner() {
        if (!this._spinner) {
            this._spinner = new Spinner(this.button);
        }
        return this._spinner;
    }

    get notices() {
        return this.$form.closest('.ep-settings').find('.ep-settings-notices');
    }

    bind() {
        this.$form.on('submit', this.onFormSubmit.bind(this));
    }

    onFormSubmit(e) {
        e.preventDefault();
        this.submit();
    }

    onSettingsSave(data) {
        this.spinner.hide();
        this.notices.html(data.message);
    }

    submit() {
        let data = this.$form.serialize() + '&action=ep_settings_save';

        this.spinner.show();
        this.notices.html('');

        this.xhr = $.ajax({
            url: ep_options.ajax_url,
            method: 'POST',
            data: data,
            success: this.onSettingsSave.bind(this)
        });
    }
}

const forms = [];

$(function() {
    $('.ep-settings .ep-form').each(function() {
        forms.push(new SettingsForm(this));
    });
});