import Spinner from '../component/Spinner';
import $ from 'jquery';

require('./scss/categories.scss');

module.exports = function() {

    $('.widget.widget-ep-categories').each(function(index, widget) {

        let $widget = $(widget),
            $terms = $widget.find('select'),
            $last = $widget.find('select:last-of-type'),
            $submit = $widget.find('button');

        $terms.each(function(index, term) {
            term.spinner = new Spinner(term);
            let $term = $(term);

            if ($term.find('option').length <= 1) {
                $term.prop('disabled', true);
            }
        });

        $terms.on('change', function() {
            let $term = $(this);

            if ($term.is(':last-of-type')) {
                if ($term.val() && $widget.data('autosubmit')) {
                    document.location.href = $term.find(':selected').attr('data-url');
                }
            } else {
                let $next = $terms.eq($terms.index($term) + 1);

                $next.prop('disabled', true);
                $next.find('option:not(:first-child)').remove();

                if ($term.val()) {
                    $next[0].spinner.show();

                    $.ajax({
                        url: ep_options.ajax_url,
                        method: 'POST',
                        data: {
                            action: 'ep_taxonomy',
                            widget: $widget.attr('id'),
                            parent: $term.val()
                        },
                        success: function(terms) {
                            $next[0].spinner.hide();
                            $next.prop('disabled', terms.length === 0);

                            if (terms.length === 0) {
                                $submit.prop('disabled', false);

                                if ($widget.data('autosubmit')) {
                                    document.location.href = $term.find(':selected').attr('data-url');
                                }
                            }

                            for (let i in terms) {
                                if (terms.hasOwnProperty(i)) {
                                    let $option = $('<option></option>')
                                        .attr('value', terms[i].id)
                                        .attr('data-url', terms[i].url)
                                        .html(terms[i].name);

                                    $next.append($option);
                                }
                            }
                        }
                    });
                }
            }
        });

        $submit.on('click', function() {
            if ($last.val()) {
                document.location.href = $last.val();
            }
        });
    });
};