<?php
add_action('admin_menu', 'ep_core_settings_menu');
add_action('wp_ajax_ep_settings_save', 'ep_core_settings_save');

/**
 * Dodaje stavku u administracijski izbornik.
 */
function ep_core_settings_menu()
{
	/*add_menu_page(
		'EP Upravljačka ploča',
		'EP Postavke',
		'manage_options',
		'ep-settings',
		'ep_core_settings_page',
		'dashicons-forms',
		'2.0'
	);*/
}

/**
 * Renderira stranicu s postavkama.
 */
function ep_core_settings_page()
{
    wp_enqueue_script('ep-admin-settings');

	$tabs = array_map(function(array $tab) {
		if (!isset($tab['id']) || empty($tab['id'])) {
			throw new \InvalidArgumentException('Tab mora imati id.');
		}

		return array_merge([
			'id' => '',
			'title' => '',
		], $tab);
	}, apply_filters('ep/settings/tabs', []));
	?>
	<div class="wrap ep">
		<h2><?= get_admin_page_title(); ?></h2>

		<div class="ep-settings">
            <div class="ep-settings-notices"></div>

			<div class="tab-container">
				<ul class="nav nav-tabs">
					<?php foreach ($tabs as $i => $tab): ?>
						<li class="nav-item">
							<a class="nav-link<?= 0 === $i ? ' active' : ''; ?>" href="#<?= $tab['id']; ?>" data-toggle="tab">
								<?= $tab['title']; ?>
							</a>
						</li>
					<?php endforeach; ?>
				</ul>

				<div class="tab-content">
					<?php foreach ($tabs as $i => $tab): ?>
						<div class="tab-pane fade<?= 0 === $i ? ' show active' : ''; ?>" id="<?= $tab['id']; ?>">
							<?php do_action("ep/settings/tab/{$tab['id']}/content"); ?>
						</div>
					<?php endforeach; ?>
				</div>
			</div>
		</div>
	</div>
	<?php
}

/**
 * Sprema postavke.
 */
function ep_core_settings_save()
{
    $optionName = $_POST['option_name'];
    $option = $_POST['settings'] ?? [];

    update_option($optionName, $option);

    wp_send_json([
        'message' => '<div id="setting-error-settings_updated" class="updated settings-error notice is-dismissible"> 
<p><strong>Postavke spremljene.</strong></p><button type="button" class="notice-dismiss"><span class="screen-reader-text">Isključi ovu napomenu.</span></button></div>',
    ]);
}