<?php
// Mičemo emoji stvari.
remove_action('wp_head', 'print_emoji_detection_script', 7);
remove_action('admin_print_scripts', 'print_emoji_detection_script');
remove_action('wp_print_styles', 'print_emoji_styles');
remove_action('admin_print_styles', 'print_emoji_styles');


/**
 * Registrira skripte i stilove.
 */
function ep_core_assets()
{
	wp_register_script('ep-core', EP_CORE_URL . 'dist/ep-core.min.js', ['jquery'], EP_CORE_VERSION);
}

/**
 * Registrira skripte i stilove za admin.
 */
function ep_core_admin_assets()
{
	wp_register_script('ep-admin-settings', EP_CORE_URL . 'dist/ep-settings.min.js', ['jquery'], EP_CORE_VERSION);
}

/**
 * Registrira stvari za customizer.
 */
function ep_core_customizer_controls()
{
	wp_enqueue_script('ep-customizer', EP_CORE_URL . 'dist/ep-customizer.min.js', ['customize-controls'], EP_CORE_VERSION);
}

/**
 * Registrira stvari za preview customizera.
 */
function ep_core_customizer_preview()
{
	wp_enqueue_script('ep-customizer-preview', EP_CORE_URL . 'dist/ep-customizer-preview.min.js', ['customize-preview-widgets'], EP_CORE_VERSION);
}

/**
 * Inicijalizira EP komponente.
 */
function ep_core_components()
{
	$spinner = new \EpOld\Component\Spinner();
	$spinner->init();
}

/**
 * Dodajemo postavke za js dio.
 */
function ep_core_inline_scripts()
{
	printf('<!--suppress ES6ConvertVarToLetConst, JSUnusedLocalSymbols, UnterminatedStatementJS, BadExpressionStatementJS -->
<script>var ep_options = %s;</script>', json_encode([
		'ajax_url' => admin_url('admin-ajax.php'),
	]));
}