<?php

add_filter('ep/settings/tabs', function(array $tabs) {
	$tabs[] = [
		'id' => 'smtp',
		'title' => 'SMTP',
	];
	return $tabs;
});

add_action('phpmailer_init', function(PHPMailer $mailer) {

    $options = get_option('ep_smtp');

    $host = $options['host'] ?? null;
    $port = $options['port'] ?? 25;
    $username = $options['username'] ?? null;
    $password = $options['password'] ?? null;

    if (isset($options['enabled']) && '1' === $options['enabled']) {
	    $mailer->isSMTP();
	    $mailer->SMTPDebug = 0;
	    $mailer->SMTPAuth = true;
	    $mailer->Host = $host;
	    $mailer->Port = $port;
	    $mailer->Username = $username;
	    $mailer->Password = $password;
    }
});

add_action('ep/settings/tab/smtp/content', function() {

	$options = get_option('ep_smtp', []);
	$enabled = isset($options['enabled']) && '1' === $options['enabled'];

	?>
	<form class="ep-form">
        <div class="form-check">
            <label class="form-check-label">
                <input type="checkbox" id="ep-smtp-enabled" name="settings[enabled]" class="form-check-input" value="1"<?= $enabled ? ' checked' : ''; ?>>
                Omogući slanje mailova preko SMTPa
            </label>
        </div>

		<div class="form-group">
			<label for="ep-smtp-host">Host</label>
			<input type="text" id="ep-smtp-host" name="settings[host]" class="form-control" value="<?= $options['host'] ?? ''; ?>">
		</div>

		<div class="form-group">
			<label for="ep-smtp-port">Port</label>
			<input type="text" id="ep-smtp-port" name="settings[port]" class="form-control" value="<?= $options['port'] ?? ''; ?>">
		</div>

		<div class="form-group">
			<label for="ep-smtp-username">Korisničko ime</label>
			<input type="text" id="ep-smtp-username" name="settings[username]" class="form-control" value="<?= $options['username'] ?? ''; ?>">
		</div>

		<div class="form-group">
			<label for="ep-smtp-password">Lozinka</label>
			<input type="password" id="ep-smtp-password" name="settings[password]" class="form-control" value="<?= $options['password'] ?? ''; ?>">
		</div>

		<input type="hidden" name="option_name" value="ep_smtp">

		<button type="submit" class="btn btn-primary">
			<?= __('Save Changes'); ?>
		</button>
	</form>
	<?php
});

