const path = require('path');
const ProvidePlugin = require('webpack/lib/ProvidePlugin');
const UglifyJSWebpackPlugin = require('uglifyjs-webpack-plugin');

module.exports = {
    entry: {
        'ep-core': './assets/ep-core.js',
        'ep-customizer': './assets/ep-customizer.js',
        'ep-customizer-preview': './assets/ep-customizer-preview.js',
        'ep-settings': './assets/ep-settings.js',
    },
    output: {
        filename: '[name].min.js',
        path: path.resolve(__dirname, 'dist'),
        library: 'ep'
    },

    plugins: [
        new UglifyJSWebpackPlugin(),
        new ProvidePlugin({
            $: 'jquery',
            Popper: ['popper.js', 'default']
        })
    ],

    module: {
        rules: [{
            test: /\.scss$/,
            exclude: /node_modules/,
            use: [{
                loader: 'style-loader'
            }, {
                loader: 'css-loader'
            }, {
                loader: 'postcss-loader',
                options: {
                    plugins: [
                        require('autoprefixer'),
                        require('cssnano')
                    ]
                }
            }, {
                loader: 'sass-loader'
            }]
        }, {
            test: /\.js$/,
            loader: 'babel-loader',
            options: {
                presets: ['env']
            }
        }]
    },

    resolve: {
        alias: {
            jquery: 'jquery/src/jquery'
        }
    },

    externals: {
        jquery: 'jQuery',
    }
};